# Tweaks for Macbook Pro 2017 13,3" Touchbar on Fedora 40
> [!CAUTION]
> Dont delete the MacOS **EFI** partition, it holds the firmware needed to get the **Touchbar** working.

## Fix usb Ethernet for most adapters:
add this udev rule:
https://raw.githubusercontent.com/wget/realtek-r8152-linux/master/50-usb-realtek-net.rules

## Add Touchbar Drivers
### Include in Dracut
add this to **/etc/dracut.conf.d/macbook.conf**
```bash
add_drivers+=" applespi intel_lpss_pci spi_pxa2xx_platform apple-ib-tb "
```

### Install DKMS
```bash
sudo dnf install dkms
```

### Add driver files to DKMS
```bash
cd /tmp
git clone https://github.com/lorre851/macbook12-spi-driver
cd macbook12-spi-driver
sudo dkms add .
```

### Install Driver
```bash
sudo dkms install -m applespi -v 0.1 -k <current kernel | pending kernel>
```

### Regenerate Initramfs
```bash
sudo dracut --force
```

## Reboot

## Fix Audio
Install this: https://github.com/davidjo/snd_hda_macbookpro

If you didnt reboot, do it now, it is important, to not have any kernel updates pending when doing this.

### Install Dependencies
```bash
sudo dnf install gcc kernel-devel make patch wget git kernel-devel
```

### Clone Project to a Save location
```bash
mkdir -p ~/Drivers && cd Drivers
git clone https://github.com/davidjo/snd_hda_macbookpro.git
```

### Install it
in the repo folder run
```bash
sudo ./install.cirrus.driver.sh
```
